% LDApred 

%I/O: [class]=LDApred(sample,data,group);

function [class]=LDApred(sample,data,group);

%sort group
[G,GN]=grp2idx(group);
ngroups=length(GN);
[M,nmeas]=size(data);
[data1,Mdata]=mncn(data);
[MS,NS]=size(sample);
sample1=scale(sample,Mdata);

% pooled covariance matrix
gmeans = ones(ngroups, nmeas);S = zeros(nmeas,nmeas,ngroups);
for k=1:ngroups
    a=find(G == k);
    gmeans(k,:) = mean(data1(a,:),1);
    ratio(k)=length(a)/length(G);
    for i=1:length(a)
        S(:,:,k) = S(:,:,k) + (data1(a(i),:)-gmeans(k,:))'*(data1(a(i),:)-gmeans(k,:));
    end
end
Stot = sum(S,3)/(M-ngroups);

[V,E] = eig(Stot);

inStot = zeros(size(Stot));
for i = 1:size(E,1)
    inStot = inStot + V(:,i) * V(:,i)'/E(i,i);
end  

%classify data using all data
for o=1:M
    for k=1:ngroups
        d(k) = (data1(o,:) - gmeans(k,:)) * inStot * (data1(o,:) - gmeans(k,:))' + log(det(Stot)) - 2 * log(ratio(k));
    end
    [mind, scores(o)] = min(d);
end

%classify sample using data
for o=1:MS
    for k=1:ngroups
        ds(k) = (sample1(o,:) - gmeans(k,:)) * inStot * (sample1(o,:) - gmeans(k,:))' + log(det(Stot)) - 2 * log(ratio(k));
    end
    [mind, class(o)] = min(ds);
end