% PCDApred: predict new samples on PCDA model

function [class,D]=PCDApred(sample,X,classes,pc)

options=pca('options');
options.plots='none';
options.display='none';

% autoscale modelling data and  sample data
[Training,mtr,stdtr]=auto(X);
Test=scale(sample,mtr,stdtr);


%  pca training set
[m,n]=size(Training);
[Gtr,GNtr]=grp2idx(classes);
[sc,lo,s,maxpc]=scoloatno(Training);

score=sc(:,1:pc);
load=lo(:,1:pc);

nc=length(GNtr);
for i=1:nc
    meansc(i,:)=mean(score(find(Gtr==i),:));
end

nlv=floor(min([m/4,n,pc,nc]));
model=pca(meansc,min(nc-1,nlv),options);
clear meansc
loada=model.loads{2}; %discriminant vector in 'score space'

scores=score*loada; 

D=load/(load'*load)*loada; %discriminant vector in original space

Tscores=Test*load/(load'*load)*loada;

%classififcation rule and classification of sample
 %most of group 1 have negative scores
if length(find(scores(find(Gtr==1))<0))>length(find(scores(find(Gtr==1))>0))
    %half of more of group 2 have positive scores
    if length(find(scores(find(Gtr==2))>0))>=length(find(scores(find(Gtr==2))<0)) 
        Sign(1)=-1; Sign(2)=1;
        for i=1:size(Tscores,1) %assign class to test samples
            sign_class(i)=sign(Tscores(i));
            class(i)=find(Sign==sign_class(i));
        end
        for t=1:size(Training,1) %assign class to training samples
            sign_Xclass(t)=sign(scores(t));
            Xclass(t)=find(Sign==sign_Xclass(t));
        end
    %most of group 2 have negative scores
    elseif length(find(scores(find(Gtr==2))<0))>length(find(scores(find(Gtr==2))>0)) 
        Sign(1)=0;
            class(1:size(Tscores,1))=NaN; %not possible to classify
            Xclass(1:size(scores,1))=NaN;
        end
    
%most of group 1 have positive scores
elseif length(find(scores(find(Gtr==1))>0))>length(find(scores(find(Gtr==1))<0)) 
    %half of more of group 2 have negative scores
    if length(find(scores(find(Gtr==2))<0))>=length(find(scores(find(Gtr==2))>0)) 
        Sign(1)=1; Sign(2)=-1;
        for i=1:size(Tscores,1) %assign class to test samples
            sign_class(i)=sign(Tscores(i));
            class(i)=find(Sign==sign_class(i));
        end
        for t=1:size(Training,1) %assign class to training samples
            sign_Xclass(t)=sign(scores(t));
            Xclass(t)=find(Sign==sign_Xclass(t));
        end
    %most of group 2 have positive scores
    elseif length(find(scores(find(Gtr==2))>0))>length(find(scores(find(Gtr==2))<0)) 
        Sign(1)=0;
        class(1:size(Tscores,1))=NaN; %not possible to classify
        Xclass(1:size(scores,1))=NaN;
    end

%exactly half of group 1 have positive scores    
elseif length(find(scores(find(Gtr==1))>0))==length(find(scores(find(Gtr==1))<0)) 
    %most of group 2 have negative scores
    if length(find(scores(find(Gtr==2))<0))>length(find(scores(find(Gtr==2))>0))
        Sign(1)=1; Sign(2)=-1;
        for i=1:size(Tscores,1) %assign class to test samples
            sign_class(i)=sign(Tscores(i));
            class(i)=find(Sign==sign_class(i));
        end
        for t=1:size(Training,1) %assign class to training samples
            sign_Xclass(t)=sign(scores(t));
            Xclass(t)=find(Sign==sign_Xclass(t));
        end
    %most of group 2 have positive scores
    elseif length(find(scores(find(Gtr==2))>0))>length(find(scores(find(Gtr==2))<0))
        Sign(1)=-1; Sign(2)=1;
        for i=1:size(Tscores,1) %assign class to test samples
            sign_class(i)=sign(Tscores(i));
            class(i)=find(Sign==sign_class(i));
        end
        for t=1:size(Training,1) %assign class to training samples
            sign_Xclass(t)=sign(scores(t));
            Xclass(t)=find(Sign==sign_Xclass(t));
        end
    % half of group 2 have positive scores
    else
        Sign(1)=0;
        class(1:size(Tscores,1))=NaN; %not possible to classify
        Xclass(1:size(scores,1))=NaN;
    end
end
S=Sign(1);