% PCDA cross validation for variable selection with rank products

%I: X, classes
%O: rp(rankproduct), var_index(best variables)

function [rp, var_index]=RP_1cv(X,classes)

[objects,vars]=size(X);

outer1=randperm(20)';
outer2=[20+randperm(19) 0]';

% outer cross (20 fold)
i=[1 2];
for outer=1:10
     ind_outer=[outer1(i); outer2(i)];
    train =delsamps([0:39]', 1+[outer1(i); outer2(i)]);
    ind(outer,:)=[ind_outer' train'];
    ind_outer=ind_outer(ind_outer~=0);
    train=train(train~=0);
    test_outer=X(ind_outer,:);
    Tclass_outer=classes(ind_outer);
    X_outer=X(train,:);
    Xclass_outer=classes(train);
    i=i+2;

      % build models using different numbers of components
        for pc=2:20
            [outerclass,V(:,outer,pc)]=PCDApred(test_outer,X_outer,Xclass_outer,pc);
            loss(outer,pc)=length(find(outerclass'~=[Tclass_outer]));
        end
     end %outer cross ends
    % find best number of components
    som=sum(loss);
    [m npc]=min(som(2:20));
    npc=npc+1;

    % rank products
    for i=1:10
        D(:,i)=V(:,i,npc);
    end
    Dabs=abs(D);
    for i=1:10
        [y(i,:),j(i,:)]=sort(Dabs(:,i));
    end
    for i=1:10
        for m=1:vars
            rank(i,m)=(vars+1)-find(j(i,:)==m);
        end
    end
    for m=1:vars
        rankpr(m)=prod(rank(:,m));
    end
    [rp,var_index]=sort(rankpr);